#include <gtk/gtk.h>

gboolean
window_expose (GtkWidget      *widget,
               GdkEventExpose *event,
               gpointer        user_data)
{
  cairo_t *cr;
  cairo_surface_t *surface = (cairo_surface_t *) user_data;

  cr = gdk_cairo_create (gtk_widget_get_window (widget));

  cairo_set_source_surface (cr, surface, 0, 0);

  cairo_paint (cr);

  cairo_destroy (cr);

  return TRUE;
}

int
main (int    argc,
      char **argv)
{
  GtkWidget *window;
  cairo_surface_t *surface;

  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_widget_set_app_paintable (GTK_WIDGET (window), TRUE);

  surface = cairo_image_surface_create_from_png ("cairo-banner.png");

  g_signal_connect (window, "expose-event", G_CALLBACK (window_expose),
                    surface);

  g_signal_connect (window, "delete-event", G_CALLBACK (gtk_main_quit), NULL);

  gtk_widget_show (window);

  gtk_main ();

  cairo_surface_destroy (surface);

  return 0;
}
